#include "volby.h"
#include <stdio.h>
#include <stdlib.h>
#define MX 100000

static struct hr
{
  int to;
  struct hr *next;
} hrany[6 * MX];
static int avol[MX];
static struct hr *graf[MX];
static int hlasy[5];
static int prvni_pocet;
static int n;

static void
adde (int u, int v)
{
if (u < 0 || u >= n || v < 0 || v >= n) exit(42);
  static int laste;
  struct hr *nw = hrany + laste++;
if (laste >= 6*MX) exit(43);
for (struct hr *h = graf[u]; h; h=h->next) if (h->to == v) exit(49);
  nw->to = v;
  nw->next = graf[u];
  graf[u] = nw;
}

void spioni (int an, int m, int zn[][2], int vol[])
{
  int i;
if (an > MX) exit(44);

  n = an;
  for (i = 0; i < n; i++)
    {
      avol[i] = vol[i];
      if (vol[i] < 0 || vol[i] >= 5) exit(44);
    }

  for (i = 0; i < m; i++)
    {
      adde (zn[i][0], zn[i][1]);
      adde (zn[i][1], zn[i][0]);
    }

  prvni_pocet = 1;
}

void zmen_nazor (int kdo, int kand)
{
if (kdo < 0 || kdo >= n || kand < 0 || kand >= 5) exit(42);
  int old = avol[kdo];
  struct hr *ah;

  avol[kdo] = kand;
  if (prvni_pocet || old == kand)
    return;

  for (ah = graf[kdo]; ah; ah = ah->next)
    {
      if (avol[ah->to] == old)
	hlasy[old]--;
      else if (avol[ah->to] == kand)
	hlasy[kand]++;
    }
}

void 
pocet_bodu (int kam[])
{
  int i;

  if (prvni_pocet)
    {
      struct hr *ah;
      prvni_pocet = 0;

      for (i = 0; i < n; i++)
	{
	  int kand = avol[i];
	  for (ah = graf[i]; ah; ah = ah->next)
	    if (i < ah->to && avol[ah->to] == kand)
	      hlasy[kand]++;
	}
    }

  for (i = 0; i < 5; i++)
    kam[i] = hlasy[i];
}
